if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SystemWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SystemWidget"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.SystemWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
/**
 * Summary: Define common action in core iwidget level.
 */
dojo.declare("com.ibm.mm.builder.iwidget.SystemWidget", null, {
	
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	cwm: com.ibm.mm.builder.coreWidgetsMessages,
	eventService: com.ibm.mashups.services.ServiceManager.getService("eventService"),
	LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass),
	
	onPageModeChanged: function(iEvent){
		var pl = iEvent.payload;
		if(!pl || pl.length < 2){ return; }
		var modeName = "on"+ pl.charAt(0).toUpperCase() + pl.substring(1).toLowerCase();
		if (this[modeName]) { this[modeName](); }
	},
	
	getViewRootNode: function(){
		return this._getModeRootNode("view");
	},
	
//	//todo cannot get edit root if edit dom shows in dialog
//	getEditRootNode: function(){
//		return this._getModeRootNode("edit");
//	},
	
	_getModeRootNode: function(mode){
        var node = dojo.query("> .iw-Content." + mode, this.iContext.getRootElement())[0]; //spec
        if (!node) {
            node = dojo.query("> .mm_Content." + mode, this.iContext.getRootElement())[0]; //legacy
        }
		return node;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.SystemTemplatedWidget", com.ibm.mm.builder.iwidget.SystemWidget, {

	onView: function(){
		this._loadMode("View");
	},
	
	onEdit: function(){
		this._loadMode("Edit");
	}, 
	
	_loadMode: function(mode){
		//only load once
		if (this[mode + "IsLoaded"]) { return; }
		
		var methods = {};
		for(var elementName in this){
			if(typeof this[elementName] == "function" && !(elementName in this.constructor.superclass)){
	        	methods[elementName] = dojo.hitch(this, this[elementName]);
			}
		}
		
		var modeNode = this["get"+ mode+"RootNode"]();
		var modeNodeContent = dojo.isIE ? com.ibm.mm.builder.utils.htmlUtil.addMissingQuoteInTitle(modeNode.innerHTML) : modeNode.innerHTML;
		//to make child object access template widget's attach points
		var modeTemplate = new com.ibm.mm.builder.iwidget.TemplatedWidget(
			//mix in the methods of this to support dojoAttachEvent
			dojo.mixin({templateString: modeNodeContent}, methods)
		);
		var attachedNodes = {};
		//mixin attachPoints in context
		for(var nn in modeTemplate){
			if (Object.prototype.hasOwnProperty.call(modeTemplate,nn)) {
				var rr = modeTemplate[nn];
				if ((rr && rr.nodeType == 1 && nn !== "domNode") || rr instanceof dijit._Widget) {
					attachedNodes[nn] = rr;
				}
			}
		}
		dojo.mixin(this, attachedNodes);
		modeNode.innerHTML = "";
		modeNode.appendChild(modeTemplate.domNode);
		this[mode + "IsLoaded"] = true;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.TemplatedWidget", [dijit._Widget, dijit._Templated], {
	
	widgetsInTemplate: true,
	
    postMixInProperties: function(){
        var t = this.templateString;
        if (t) {
			this.templateString = dojo.string.substitute(t, com.ibm.mm.builder.coreWidgetsStrings, function(v, k){
				return v || "$ {" + k + "}"; //error if removing the blank space between $ and {
			});
		}
    }
});

}
