dojo.provide("com.ibm.pb.decorations.ControlMenu");

dojo.require("com.ibm.pb.contextMenu.ShadowContextMenuLoader");
dojo.require("com.ibm.pb.logging.Loggable");

dojo.declare("com.ibm.pb.decorations.ControlMenu", com.ibm.pb.logging.Loggable, {
	
	builderFactory: com.ibm.mashups.builder.model.Factory,
	
	baseContextMenuId: "widgetActions",
	
    constructor: function(controlId, contextMenuId, baseContextMenuId) {
        var mname = "constructor", lgr = this.LOGGER, me = this;
        this._connections = [];
        if(baseContextMenuId) {
            this.baseContextMenuId = baseContextMenuId;
        }
        this.controlId = controlId;
        this.contextMenuId = contextMenuId;
        this.contextMenuLoader = new com.ibm.pb.contextMenu.ShadowContextMenuLoader(this.baseContextMenuId);
        this.builderFactory.getContextMenuModel().registerContextMenu(contextMenuId, this.contextMenuLoader);
        this.evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
        
        // lookup the widget window id based on the control Id
        this.windowId = controlId; // we can assume that window ID and control ID are always the same, even in live preview
        
        dojo.forEach(["com.ibm.mashups.iwidget.widgetmodechanged", "com.ibm.mashups.iwidget.widgetwindowstatechanged"], function(evt) {
            this._connections.push(this.evtSvc.subscribeEvent(evt, this, this._checkChange));
        }, this);
        
        dojo.forEach(["com.ibm.mashups.builder.moveAction","com.ibm.mashups.builder.hideWidget","com.ibm.mashups.builder.displayWidget"], function(evt) {
            this._connections.push(this.evtSvc.subscribeEvent(evt, this, function(id){
                // payload is simple string id
                this._checkChange({id: id});
            }));
        }, this);
        
        this._connections.push(this.evtSvc.subscribeEvent("com.ibm.mashups.builder.changePageMode", this, function(){
            this._checkChange({id: this.windowId}); // not part of event payload
        }));
    },
    _checkChange: function(obj){
        var mname = "_checkChange", lgr = this.LOGGER, me = this;
        lgr.entering(mname, arguments);
        if(this.windowId == obj.id) {
            lgr.trace(mname, "Firing change event for widget context menu ${0}", [this.windowId]);
            this.contextMenuLoader.onChange();
        }
        lgr.exiting(mname, arguments);
    },
	destroy: function() {
		this.builderFactory.getContextMenuModel().registerContextMenu(this.contextMenuId, null);
		delete this.contextMenuLoader;
		while(this._connections.length > 0) {
			this.evtSvc.unsubscribeEvent(this._connections.shift());
		}
	}
});