dojo.provide("com.ibm.mm.builder.systemwidget.TemplateSelectDialog");

dojo.require("com.ibm.pb.iwidget.iWidgetBase");
dojo.require("com.ibm.widgets.TemplateSelectDialog");
dojo.require("com.ibm.customize.LotusPaletteContainer");

dojo.declare("com.ibm.mm.builder.systemwidget.TemplateSelectDialog", [com.ibm.pb.iwidget.iWidgetBase], {
	
	controller: null,
	
	onLoad: function() {
		var mname = "onLoad", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		this.wid = "_"+this.iContext.widgetId+"_";
		var attrMix = this.getItemSetValues([
			"controller" ,	// Object
		]);
		this.convertMapTypes(attrMix, ["controller"], "Object");
		dojo.mixin(this, attrMix);
		this.model = this.controller.getTreeModel();
		this.nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		this.nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
		lgr.exiting(mname, arguments);
	},
	onUnload: function() {
		this._cleanupInternalWidget();
	},
	_cleanupInternalWidget: function() {
		if(this.widget) {
			if(this._changeConnection) {
				dojo.disconnect(this._changeConnection);
			}
			this.widget.destroy();
		}
	},
	_initInternalWidget: function() {
		var me = this;
		this._cleanupInternalWidget();
		this.widget = new com.ibm.widgets.TemplateSelectDialog({
			selectedResourceId: this._selectedTemplateId
		}, this.iContext.getElementById(this.wid + "contents"));
		this._changeConnection = dojo.connect(this.widget, "onChange", this, "_onChange");
		this.widget.startup();
	},
	_onChange: function(value) {
		var mname = "_onChange", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		var payload = {};
		payload.sourceWidget = this._sourceId;
		payload.value = value;
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._sourceId, "onTemplateSelectChanged", value, null, this.iContext.widgetId);
		lgr.exiting(mname, arguments);
	},
	onTemplateSelect: function(iEvent) {
		var mname = "onTemplateSelect", lgr = this.LOGGER;
		lgr.entering(mname, arguments);
		if(this.widget && this.widget.open) { return; }
		this._sourceId = iEvent.source;
		this._selectedTemplateId = iEvent.payload;
        
        if (!this.widget) {
            this._initInternalWidget();
        }
        
        // only show the widget if a selected template id is passed in
        if (iEvent.payload !== "") {
            this.widget.focus();   // show the widget
        }
        else {
            //  otherwise the widget fetches the data to populate itself and
            //  signals back the default id is by calling _onChange
            //  without the dialog ever displaying
            this.widget.onSubmit();
        }
        
		lgr.exiting(mname, arguments);
	}
});
