/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.content.StaticContentPage");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.ModifiableMetaData");
dojo.require("com.ibm.mashups.enabler.content.ContentPage");
//<INTERFACE>
/**
 * This interface exposes the contents of the static template for a content
 * provider. The template defines containers, also referred to as dynamic spots,
 * which may be populated with widgets. Use this model to identify containers,
 * or to modify the contents of the template. Use the layout model to populate
 * the containers with controls, respectively widgets.
 * 
 * @see com.ibm.mashups.enabler.model.LayoutModel
 * @see com.ibm.mashups.enabler.layout.LayoutContainer
 * @see com.ibm.mashups.enabler.layout.LayoutControl
 * 
 * @since 2.4
 * 
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.content.StaticContentPage", [com.ibm.mashups.enabler.content.ContentPage, com.ibm.mashups.enabler.ModifiableMetaData], {

	/**
	 * Returns the markup of this static content provider.
	 * @return {com.ibm.mashups.enabler.Deferred} A deferred object used to start this operation,
	 * never <code>null</code>. The return value when executed through the
	 * deferred object is the static markup.
	 */
	getStaticMarkup : function() {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.getStaticMarkup');
	},

	/**
	 * Sets the markup of this static content provider.
	 * @param {String} markup the markup, must not be <code>null</code>
	 * @type void
	 */
	setStaticMarkup : function(markup) {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.setStaticMarkup');
	},

	/**
	 * Confirms whether setStaticMarkup() can be performed.
	 * @param {String} markup see parameter description of method to confirm
	 * @return {Boolean} <code>true</code> if it can be performed, <code>false</code> otherwise
	 */
	confirmSetStaticMarkup : function(markup) {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.confirmSetStaticMarkup');
	},

	/**
	 * Refreshes the static content when the underlying model is committed.
	 * @return {void}
	 */
	refreshStaticMarkup : function() {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.refreshStaticMarkup');
	},

	/**
	 * Confirms whether refreshStaticMarkup() can be performed.
	 * @return {Boolean} <code>true</code> if it can be performed, <code>false</code> otherwise
	 */
	confirmRefreshStaticMarkup : function() {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.confirmRefreshStaticMarkup');
	},

	/**
	 * Returns the URL of the static content.
	 * @return {String} absolute url to the static content
	 */
	getStaticContentURL : function() {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.getStaticContentURL');
	},

	/**
	 * Sets the url to the static content.
	 * @param {String} url the absolute url to the static content
	 * @type void
	 */
	setStaticContentURL : function(url) {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.setStaticContentURL');
	},

	/**
	 * Confirms whether setStaticContentURL() can be performed.
	 * @param {String} url see parameter description of method to confirm
	 * @return {Boolean} <code>true</code> if it can be performed, <code>false</code> otherwise
	 */
	confirmSetStaticContentURL : function(url) {
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.StaticContentPage.confirmSetStaticContentURL');
	}
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.content.StaticContentPageImpl");
