/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.UserModel");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.ListModel");
dojo.require("com.ibm.mashups.enabler.Locator");
dojo.require("com.ibm.mashups.enabler.user.AnonymousMode");
dojo.require("com.ibm.mashups.enabler.user.VirtualType");
dojo.require("com.ibm.mashups.enabler.user.Entity");
dojo.require("com.ibm.mashups.enabler.user.User");
dojo.require("com.ibm.mashups.enabler.user.CurrentUser");
dojo.require("com.ibm.mashups.enabler.user.Group");
dojo.require("com.ibm.mashups.enabler.user.Attribute");
dojo.require("com.ibm.mashups.enabler.Commitable");
//<INTERFACE>
/**
 * Interface for a user model used to search for user and groups
 * @ibm-api
 * @ibm-module UserModel
 */
dojo.declare("com.ibm.mashups.enabler.model.UserModel", [com.ibm.mashups.enabler.Commitable, com.ibm.mashups.enabler.ListModel, com.ibm.mashups.enabler.Locator], {
    /**
     * Returns the mode in which the anonymous user is accessing the system.
     * @return {com.ibm.mashups.enabler.user.AnonymousMode} the mode in which the anonymous user is accessing the system. Never <code>null</code>.
     */
    getAnonymousMode: function(){
    },
    
    /**
     * Returns the current user.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The return value
     * when executed through the deferred object is the current user or <code>null</code>.
     */
    findCurrentUser: function(){
    },
    
    /**
     * Returns a user array that matches the LDAP query attributeName=attributeValue
     * @param {String} attributeName name of the LDAP query
     * @param {String} attributeValue value of the LDAP query
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The return value
     * when executed through the deferred object is an array of User objects.
     * Never <code>null</code>.
     */
    findUsersByAttribute: function(attributeName, attributeValue){
    },
    
    /**
     * Returns the group with the given id or null if no such group exists
     * @param {String} id the id
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The return value
     * when executed through the deferred object is the group with the given id
     * or <code>null</code>.
     */
    findGroupByID: function(id){
        return new Deferred();
    },
    
    /**
     * Returns a group array that matches the LDAP query attributeName=attributeValue
     * @param {String} attributeName name of the LDAP query
     * @param {String} attributeValue value of the LDAP query
     * @type com.ibm.mashups.enabler.Deferred
     * @return a deferred object used to start this operation. The return value
     * when executed through the deferred object is an array of Group objects.
     * Never <code>null</code>.
     */
    findGroupsByAttribute: function(attributeName, attributeValue){
        return new Deferred();
    },
    
    /**
     * Returns an array of attributes for the searchable Group attributes in the
     * user repository.
     * @type com.ibm.mashups.enabler.user.Attribute[]
     * @return an array of searchable group attributes. Never <code>null</code>.
     */
    findGroupAttributes: function(){
        return [];
    },
    
    /**
     * Returns an array of attributes for the searchable User attributes in the
     * user repository.
     * @type  com.ibm.mashups.enabler.user.Attribute[]
     * @return an array of searchable user attributes. Never <code>null</code>.
     */
    findUserAttributes: function(){
        return [];
    },
    
    /**
     * Returns an array of Virtual Users (like Anonymous)
     * @type  com.ibm.mashups.enabler.user.User[]
     * @return an array registered virtual users. Never <code>null</code>.
     */
    getVirtualUsers: function(){
        return [];
    },
    
    /**
     * Returns an array of Virtual Groups (like All Authenticated)
     * @type  com.ibm.mashups.enabler.user.Group[]
     * @return an array registered virtual groups. Never <code>null</code>.
     */
    getVirtualGroups: function(){
        return [];
    },
    
    /**
     * Returns the attribute names for Lookaside properties as string array.
     * Does not include non-lookaside attribute names
     * @type String[]
     * @return all lookaside attributes names as string array; never  <code>null</code>.
     */
    getLookasideAttributeNames: function(){
        return [];
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.user.UserModelImpl");
